#include <assert.h>
#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "aa.h"
#include "mem.h"


/* Watch strings evolve. */
int main(void)
{
    char buf[512];
    int ret = 0, done, first, e, life;
    const char *sep;
    struct list *p, *q;
    struct cmpd *c;

    init_periodic_table();
    putchar('>');
    while (fgets(buf, sizeof buf, stdin)) {
        p = split(readcmpd(buf), 0);
        life = 0;
        do {
            done = 1;
            first = 1;
            printf("%2d: ", life++);
            for (q = p; q; q = q->next) {
                if (!(c = q->c)) {
                    sep = " & ";
                    continue;
                }
                q->c = NULL;
                if (first)
                    first = 0;
                else
                    fputs(sep, stdout);
                if ((e = is_common(c)) || (e = is_transu(c)))
                    printf("%s", elt_name(e));
                else {
                    struct list *r;
                    prtcmpd(c);
                    done = 0;
                    r = q->next;
                    q->next = split(dtr(c), life);
                    while (q->next)
                        q = q->next;
                    q->next = r;
                }
                killcmpd(c);
                sep = ".";
            }
            putchar('\n');
        } while (!done);
        killlist(p);
        putchar('>');
    }
    if (ferror(stdin)) {
        fprintf(stderr, "an input error occurred (%s)\n", strerror(errno));
        ret = EXIT_FAILURE;
    }
    else 
        putchar('\n');
    kill_periodic_table();
    assert(numalloced() == 0);
    return ret;
}

