#include <stdio.h>
#include <stdlib.h>

#include "mem.h"

#if MEM_CHECK

static int alloced = 0;

void *xalloc(size_t n)
{
    void *p = malloc(n);
    if (!p) {
        fputs("Out of memory.\n", stderr);
        exit(EXIT_FAILURE);
    }
    ++alloced;
    return p;
}

void xfree(void *p)
{
    if (p) {
        free(p);
        --alloced;
    }
}

int numalloced(void)
{
    return alloced;
}

#else

void *xalloc(size_t n)
{
    void *p = malloc(n);
    if (!p) {
        fputs("Out of memory.\n", stderr);
        exit(EXIT_FAILURE);
    }
    return p;
}

#endif
